from .ftdi import Ftdi as Ftdi, FtdiFeatureError as FtdiFeatureError
from .misc import to_bool as to_bool
from _typeshed import Incomplete
from typing import Any, Iterable, Mapping, NamedTuple, Optional, Union
from usb.core import Device as UsbDevice

class I2cIOError(IOError): ...
class I2cNackError(I2cIOError): ...
class I2cTimeoutError(TimeoutError): ...

class I2cPort:
    FORMATS: Incomplete
    def __init__(self, controller: I2cController, address: int) -> None: ...
    def configure_register(self, bigendian: bool = ..., width: int = ...) -> None: ...
    def shift_address(self, offset: int): ...
    def read(
        self, readlen: int = ..., relax: bool = ..., start: bool = ...
    ) -> bytes: ...
    def write(
        self,
        out: Union[bytes, bytearray, Iterable[int]],
        relax: bool = ...,
        start: bool = ...,
    ) -> None: ...
    def read_from(
        self, regaddr: int, readlen: int = ..., relax: bool = ..., start: bool = ...
    ) -> bytes: ...
    def write_to(
        self,
        regaddr: int,
        out: Union[bytes, bytearray, Iterable[int]],
        relax: bool = ...,
        start: bool = ...,
    ): ...
    def exchange(
        self,
        out: Union[bytes, bytearray, Iterable[int]] = ...,
        readlen: int = ...,
        relax: bool = ...,
        start: bool = ...,
    ) -> bytes: ...
    def poll(self, write: bool = ..., relax: bool = ..., start: bool = ...) -> bool: ...
    def poll_cond(
        self,
        width: int,
        mask: int,
        value: int,
        count: int,
        relax: bool = ...,
        start: bool = ...,
    ) -> Optional[bytes]: ...
    def flush(self) -> None: ...
    @property
    def frequency(self) -> float: ...
    @property
    def address(self) -> int: ...

class I2cGpioPort:
    log: Incomplete
    def __init__(self, controller: I2cController) -> None: ...
    @property
    def pins(self) -> int: ...
    @property
    def all_pins(self) -> int: ...
    @property
    def width(self) -> int: ...
    @property
    def direction(self) -> int: ...
    def read(self, with_output: bool = ...) -> int: ...
    def write(self, value: int) -> None: ...
    def set_direction(self, pins: int, direction: int) -> None: ...

class I2CTimings(NamedTuple):
    t_hd_sta: Incomplete
    t_su_sta: Incomplete
    t_su_sto: Incomplete
    t_buf: Incomplete

class I2cController:
    LOW: int
    HIGH: int
    BIT0: int
    IDLE = HIGH
    SCL_BIT: int
    SDA_O_BIT: int
    SDA_I_BIT: int
    SCL_FB_BIT: int
    PAYLOAD_MAX_LENGTH: int
    HIGHEST_I2C_ADDRESS: int
    DEFAULT_BUS_FREQUENCY: float
    HIGH_BUS_FREQUENCY: float
    RETRY_COUNT: int
    I2C_MASK: Incomplete
    I2C_MASK_CS: Incomplete
    I2C_DIR: Incomplete
    I2C_100K: Incomplete
    I2C_400K: Incomplete
    I2C_1M: Incomplete
    log: Incomplete
    def __init__(self) -> None: ...
    def set_retry_count(self, count: int) -> None: ...
    def configure(
        self, url: Union[str, UsbDevice], **kwargs: Mapping[str, Any]
    ) -> None: ...
    def force_clock_mode(self, enable: bool) -> None: ...
    def close(self, freeze: bool = ...) -> None: ...
    def terminate(self) -> None: ...
    def get_port(self, address: int) -> I2cPort: ...
    def get_gpio(self) -> I2cGpioPort: ...
    @property
    def ftdi(self) -> Ftdi: ...
    @property
    def configured(self) -> bool: ...
    @classmethod
    def validate_address(cls, address: Optional[int]) -> None: ...
    @property
    def frequency_max(self) -> float: ...
    @property
    def frequency(self) -> float: ...
    @property
    def direction(self) -> int: ...
    @property
    def gpio_pins(self) -> int: ...
    @property
    def gpio_all_pins(self) -> int: ...
    @property
    def width(self) -> int: ...
    def read(self, address: int, readlen: int = ..., relax: bool = ...) -> bytes: ...
    def write(
        self,
        address: int,
        out: Union[bytes, bytearray, Iterable[int]],
        relax: bool = ...,
    ) -> None: ...
    def exchange(
        self,
        address: int,
        out: Union[bytes, bytearray, Iterable[int]],
        readlen: int = ...,
        relax: bool = ...,
    ) -> bytes: ...
    def poll(self, address: int, write: bool = ..., relax: bool = ...) -> bool: ...
    def poll_cond(
        self,
        address: int,
        fmt: str,
        mask: int,
        value: int,
        count: int,
        relax: bool = ...,
    ) -> Optional[bytes]: ...
    def flush(self) -> None: ...
    def read_gpio(self, with_output: bool = ...) -> int: ...
    def write_gpio(self, value: int) -> None: ...
    def set_gpio_direction(self, pins: int, direction: int) -> None: ...
